#include <sourcemod>
#include <sdktools>
#include <dhooks>

public Plugin:myinfo =
{
	name = "Prevent Team Damage",
	author = "backwards",
	description = "Prevent Team Damage",
	version = "1.0",
	url = "http://www.steamcommunity.com/id/mypassword"
}

float OldPos[MAXPLAYERS+1][3];
bool WasMoved[MAXPLAYERS+1] = {false, ...};

Handle hStartLagCompDetour;
Handle hFinishLagCompDetour;

public void OnPluginStart()
{
	Handle hGameData = LoadGameConfigFile("PreventTeamAttack");
	if (!hGameData)
	{
		SetFailState("Failed to load PreventTeamAttack gamedata.");
		return;
	}
	
	hStartLagCompDetour = DHookCreateFromConf(hGameData, "StartLagComp");
	if (!hStartLagCompDetour)
		SetFailState("Failed to setup detour for StartLagComp");
	
	if (!DHookEnableDetour(hStartLagCompDetour, false, Detour_OnStartLagComp))
		SetFailState("Failed to detour StartLagComp.");

	hFinishLagCompDetour = DHookCreateFromConf(hGameData, "FinishLagComp");
	if (!hFinishLagCompDetour)
		SetFailState("Failed to setup detour for FinishLagComp");
	
	if (!DHookEnableDetour(hFinishLagCompDetour, false, Detour_OnFinishLagComp))
		SetFailState("Failed to detour FinishLagComp.");
	
	delete hGameData;
}

public MRESReturn Detour_OnStartLagComp(Handle hParams)
{
	new attacker = DHookGetParam(hParams, 1);
	
	int attackerteam = GetClientTeam(attacker);
	
	for(int teammate = 1;teammate<MaxClients+1;teammate++)
	{
		if(IsValidClient(teammate) && IsPlayerAlive(teammate))
		{
			if(attacker == teammate)
				continue;
		
			if(GetClientTeam(teammate) != attackerteam)
				continue;

			GetEntPropVector(teammate, Prop_Send, "m_vecOrigin", OldPos[teammate]);
			TeleportEntity(teammate, Float:{9999.9, 9999.9, 9999.9}, NULL_VECTOR, NULL_VECTOR);
			WasMoved[teammate] = true;
		}
	}
	
	return MRES_Ignored;
}

public MRESReturn Detour_OnFinishLagComp(Handle hParams)
{
	for(int player = 1;player<MaxClients+1;player++)
	{
		if(IsValidClient(player) && IsPlayerAlive(player))
		{
			if(WasMoved[player])
			{
				TeleportEntity(player, OldPos[player], NULL_VECTOR, NULL_VECTOR);
				WasMoved[player] = false;
			}
		}
	}
	
	return MRES_Ignored;
}

bool IsValidClient(int client)
{
    if (!(1 <= client <= MaxClients) || !IsClientConnected(client) || !IsClientInGame(client) || IsClientSourceTV(client) || IsClientReplay(client))
        return false;
		
    return true;
}